<?php
/*
* 项目: iOrange(橘子)
* 作者: 离家出走(yzxh24)
* Email: yzxh24@gmail.com
* 主页: www.iorange.cc
*/
/* vim: set ts=4 sw=4: */
class DiscardAction extends MemberAction
{
    public function run()
    {
        $id = S::gp('id', 'G', 2);
        $task = Task::model()->findByPk($id);
        if (empty($task))
        {
            throw new iSystemException('不存在的任务');
        }

        $tasker = Tasker::model()->find(array('condition'=>'task_id='.$id.' AND uid='.$this->uid()));
        if (empty($tasker))
        {
            throw new iSystemException('你没有接受过此任务，不能放弃');
        }

        if (!$_GET['confirm'])
        {
            $message[] = '此任务完成后即可获得'.$task->reward.setting('creditname').'奖励，你确定要放弃吗？';
            $message[] = ilink('暂时不了', url('system', array('s'=>'member','c'=>'task'))).'|'.ilink('确定放弃', url('system', array('s'=>'member','c'=>'task','a'=>'discard','id'=>$id,'confirm'=>1)));
            $this->showMessage($message);
        }

        $tasker->status = 0;
        $tasker->updatedate = CDATETIME;
        $tasker->save();

        iforward(url('system', array('s'=>'member','c'=>'task')));
    }
}